Package net.sf.saxon.value

## Class QNameValue

- java.lang.Object
- - net.sf.saxon.value.AtomicValue
  - - net.sf.saxon.value.QualifiedNameValue
    - - net.sf.saxon.value.QNameValue

- All Implemented Interfaces:
    `java.lang.Iterable<AtomicValue>`, `AtomicMatchKey`, `AtomicSequence`, `GroundedValue`, `IdentityComparable`, `Item`, `Sequence`, `ConversionResult`

      public class QNameValue
      extends QualifiedNameValue

  A QName value. This implements the so-called "triples proposal", in which the prefix is retained as part of the value. The prefix is not used in any operation on a QName other than conversion of the QName to a string.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.value.QualifiedNameValue

      `qName`

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

    - ### Fields inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `NaN_MATCH_KEY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `QNameValue​(java.lang.String prefix, java.lang.String uri, java.lang.String localName)` | Constructor for a QName that is known to be valid.
    `QNameValue​(java.lang.String prefix, java.lang.String uri, java.lang.String localName, AtomicType type)` | Constructor for a QName that is known to be valid, allowing a user-defined subtype of QName to be specified.
    `QNameValue​(java.lang.String prefix, java.lang.String uri, java.lang.String localName, AtomicType type, boolean check)` | Constructor.
    `QNameValue​(StructuredQName qName, AtomicType typeLabel)` | Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicValue` | `copyAsSubType​(AtomicType typeLabel)` | Create a copy of this atomic value, with a different type label
    `boolean` | `equals​(java.lang.Object other)` | Determine if two QName values are equal.
    `AtomicValue` | `getComponent​(AccessorFn.Component part)` | Get a component.
    `BuiltInAtomicType` | `getPrimitiveType()` | Determine the primitive type of the value.
    `java.lang.Comparable` | `getSchemaComparable()` | Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.

    - ### Methods inherited from class net.sf.saxon.value.QualifiedNameValue

      `getClarkName, getEQName, getLocalName, getNamespaceURI, getPrefix, getPrimitiveStringValue, getStructuredQName, getXPathComparable, hashCode, identityHashCode, isIdentical, makeQName, toJaxpQName, toString`

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, asMapKey, atomize, checkPermittedContents, checkValidInJavascript, effectiveBooleanValue, getCanonicalLexicalRepresentation, getCardinality, getGenre, getItemType, getLength, getStringValue, getStringValueCS, getUType, head, isIdentical, isNaN, itemAt, iterate, iterator, setTypeLabel`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `asAtomic`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `isStreamed, reduce, subsequence, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### QNameValue

          public QNameValue​(java.lang.String prefix,
                            java.lang.String uri,
                            java.lang.String localName)

      Constructor for a QName that is known to be valid. No validation takes place.
      Parameters:
        `prefix` - The prefix part of the QName (not used in comparisons). Use "" to represent the default prefix.
        `uri` - The namespace part of the QName. Use "" to represent the non-namespace.
        `localName` - The local part of the QName

    - #### QNameValue

          public QNameValue​(java.lang.String prefix,
                            java.lang.String uri,
                            java.lang.String localName,
                            AtomicType type)

      Constructor for a QName that is known to be valid, allowing a user-defined subtype of QName to be specified. No validation takes place.
      Parameters:
        `prefix` - The prefix part of the QName (not used in comparisons). Use "" to represent the default prefix (but null is also accepted)
        `uri` - The namespace part of the QName. Use null to represent the non-namespace (but "" is also accepted).
        `localName` - The local part of the QName
        `type` - The type label, xs:QName or a subtype of xs:QName

    - #### QNameValue

          public QNameValue​(java.lang.String prefix,
                            java.lang.String uri,
                            java.lang.String localName,
                            AtomicType type,
                            boolean check)
                     throws XPathException

      Constructor. This constructor validates that the local part is a valid NCName.
      Parameters:
        `prefix` - The prefix part of the QName (not used in comparisons). Use "" to represent the default prefix (but null is also accepted). Note that the prefix is not checked for lexical correctness, because in most cases it will already have been matched against in-scope namespaces. Where necessary the caller must check the prefix.
        `uri` - The namespace part of the QName. Use null to represent the non-namespace (but "" is also accepted).
        `localName` - The local part of the QName
        `type` - The atomic type, which must be either xs:QName, or a user-defined type derived from xs:QName by restriction
        `check` - Supply false if the name does not need to be checked (the caller asserts that it is known to be valid)
      Throws:
        `XPathException` - if the local part of the name is malformed or if the name has a null namespace with a non-empty prefix

    - #### QNameValue

          public QNameValue​(StructuredQName qName,
                            AtomicType typeLabel)

      Constructor
      Parameters:
        `qName` - the name as a StructuredQName
        `typeLabel` - idenfies a subtype of xs:QName

  - ### Method Detail

    - #### copyAsSubType

          public AtomicValue copyAsSubType​(AtomicType typeLabel)

      Create a copy of this atomic value, with a different type label
      Specified by:
        `copyAsSubType` in class `AtomicValue`
      Parameters:
        `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
      Returns:
        the copied value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.
      Specified by:
        `getPrimitiveType` in class `AtomicValue`
      Returns:
        the primitive type

    - #### getComponent

          public AtomicValue getComponent​(AccessorFn.Component part)

      Get a component. Returns a zero-length string if the namespace-uri component is requested and is not present.
      Overrides:
        `getComponent` in class `AtomicValue`
      Parameters:
        `part` - either Component.LOCALNAME or Component.NAMESPACE indicating which component of the value is required
      Returns:
        either the local name or the namespace URI, in each case as a StringValue

    - #### equals

          public boolean equals​(java.lang.Object other)

      Determine if two QName values are equal. This comparison ignores the prefix part of the value.
      Specified by:
        `equals` in class `AtomicValue`
      Parameters:
        `other` - the other value
      Returns:
        true if the other operand is an atomic value and the two values are equal as defined by the XPath eq operator
      Throws:
        `java.lang.ClassCastException` - if they are not comparable

    - #### getSchemaComparable

          public java.lang.Comparable getSchemaComparable()

      Description copied from class: `AtomicValue`
      Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. An implementation must be provided for all atomic types.

      In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `SequenceTool.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values. This value is also returned when two values of different types are compared.

      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Specified by:
        `getSchemaComparable` in class `AtomicValue`
      Returns:
        a Comparable that follows XML Schema comparison rules